=begin
scaleGroupFloat_dj v1.65 bata
Copyright Feb 15, 2013
DukeJazz: by James Cochran

Info:
Sketchup scale tool resizes to model units.
scaleGroupFloat tool resizes to a "group object units." 

Scale:
Group Float Scaling tool scale objects, along XYZ axes.
Drop down menu's for quick and easy use of X, Y, Z, XYZ

Ratio factor multiplier:
Group  object units range 1.0e-14 to 10e+14 m by ruby float 
Object factor unit multiplier 1.0e-34 to 1.0e+34 m

Bounding size values:
Enter values of red, green, and blue size of a group object
Value of a group bound field of  a object. Example = 9902.18921080857 *1.0_m = [magnitude of length] * [multiplier] of an [Unit]
7.38896026611329 *1.0e-005_in, this how its reads, 7.38896026611329 hundred thousandth of an inch
1.8336641508 *1000.0_mm, this how its reads, 1.8336641508 thousand units of an milimeter =1.8336641508 meters
1.0 *1.0_m, this how its reads, one unit of a meter,
By keeping unit of model same as the object, then the you don't need to say the [*multiplier].

Units: ["thou|in|ft|cubit|yd|rod|furlong|mi|Ym|Zm|Em|Pm|Tm|Gm|Mm|km|hm|dam|m|dm|cm|mm|um|nm|Angstrom|pm|am|fm|zm|ym|x?|quintillionth|y?|planckto"]
Imperial units and International  mectic units of lenght.

Vector center: 
You can read or change 3dpoint vector center value.
moves group object by [x.y;z]
cumulativeScaler_dj move around (a step boxpoint)
cumulativeScaler_dj size leanear stepper
cumulativeScaler_dj move leanear stepper
Extended read out ["Show Bbox,Center,SF|Show Bbox,Center|Show Bbox|Show Center|Show SF|ShowBlank|Small format|Large format|no read format|no|Long read out|SnapLowPrecision|SnapHighPrecision|Draw vector|Draw cpoint|no|Move to target1|Move to target1 corner|Size as target1|Move and size to target1 |Save target1|Line up to target1 Red w-side|Line up to target1 Green d-side|Line up to target1 Blue h-side|no|Move to target2|Move to target2 corner|Size as target2|Move and size to target2 |Save target2|Line up to target2 Red w-side|Line up to target2 Green d-side|Line up to target2 Blue h-side|no|scale_dj|move_dj|resize_dj|cumulativeScaler_dj|keyboardScaleGroupFloat_dj|extended_options_dj|scaleMoveResize_dj"]#@list3 11

scaleGroupFloat_dj v1.0 May 11 by DukeJazz-James Cochran BSE - Ruby script

Freely use, and abuse at your own risk. Fitness of usage is not warranty implied. 
Warning do not bomb or explode group objects below 1.0e-o4 because losts of objects can occur: use the undo to make its a group to recover. 
hint - Use the outliner as a aid tool.

Thank you, have fun.

Reference helped by Google Sketchup Ruby API
Reference helped by Sahi mashtab 4 1.08.2008
Reference postReply  Re: Given a x,y,z location to move a selected group? help!by sdmitch on Thu May 17, 2012 1:48 pm - I thank you
Reference postReply  Re: Given a [x,y,z] delete a text note. Need help? by TiG by TIG on Fri Jun 01, 2012 6:35 am - I thank you
Reference helped by #Matt666#gnin gnin gnin#Didier#gnuff gnuff gnuff for def entlast_only
def entlast_only
  model = Sketchup.active_model
  sel = model.active_entities
  ss = model.selection
  n = sel.length - 1
  last_ent=sel[n]
  ss.clear
  ss.add(last_ent)
end
Reference helped headup postReply http://www.thomthom.net/thoughts/2012/0 ... development/Thomas Thomassen
Btw, you have a lot of global methods and variables. I recommend you wrap your plugins in a separate namespace - otherwise you have a potential for clashing with other plugins and each methods in the global namespace end up in every other object in Ruby.
Reference helped by Aerilius  December 8th, 2012, 3:08 pm 
module DJ
  module AnotherSketchupPlus

    def self.youSU_clearCbExit
      # ...
    end

    # ... (other methods)
  end # module AnotherSketchupPlus
end # module DJ

History:
Feb 15, 2013; scaleGroupFloat_dj v1.6 bata
-add cumulativeScaler_dj rotation around 

=end

require "sketchup.rb"
require "extensions.rb"
module DJ

module ScaleGroupFloatDJ

def ScaleGroupFloatDJ.variables_dj
@dj_x0 = [
[1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0],#bbox (size,xyz,c) 0
[1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,"Outside = Inside","ft","Outside = Inside","no"],#bbox(scale,info) 1
["1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0",1.0],#inputbox in/out bbox(size,xyz,c) 2
[1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,"Outside = Inside","ft","Outside = Inside","no",1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,"Outside = Inside","ft","Outside = Inside","no"],#inputbox in/out scale 3
[39.370078740157480314960629921260,0.02540,"ft","in","0","0","1.0","ShowBlank","1.0","on"],#cc,#data(units),switch 4 
[1.0,1.0,1.0,1.0,1.0,1.0,"w1","d1","h1","x1","y1","z1","w2","d2","h2","x2","y2","z2",0.0127,0.0127,0.0127,"90","10","undo",100],# data(scale),save 1&2 bbox(),drawBoxPoint() 5
["thou","in","ft","cubit","yd","rod","furlong","mi","Ym","Zm","Em","Pm","Tm","Gm","Mm","km","hm","dam","m","dm","cm","mm","um","nm","Angstrom","pm","am","fm","zm","ym","x?","quintillionth","y?","planckto"],# @dj_unit 6
[(1.0),(1.0),(1.0),(1.0),(1.0),(1.0),(1.0),(1.0),(1000.0e-21),(1000.0e-18),(1000.0e-15),(1000.0e-12),(1000.0e-9),(1000.0e-6),(1000.0e-3),(1000.0e-0),(100.0e-0),(10.0e-0),(1.0e-0),(10.0e+0),(100.0e+0),(1000.0e+0),(1000.0e+3),(1000.0e+6),(1000.0e+7),(1000.0e+9),(1000.0e+12),(1000.0e+15),(1000.0e+18),(1000.0e+21),(1000.0e+24),(1000.0e+27),(1000.0e+30),(1000.0e+31)],#"con" data 7
[(1000.0),(1.0/1.0),(1.0/12),(1.0/18.0),(1.0/36),(1.0/240),(1.0/7920),(1.0/63360.0),0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254],#"con" data 8
["thou|in|ft|cubit|yd|rod|furlong|mi|Ym|Zm|Em|Pm|Tm|Gm|Mm|km|hm|dam|m|dm|cm|mm|um|nm|Angstrom|pm|am|fm|zm|ym|x?|quintillionth|y?|planckto"],#@list1_9
["1.0|2.0|  0.5|3.0|  0.333333333333333333333333|4.0|  0.25|5.0|  0.2|6.0|  0.166666666666666666666667|7.0|  0.142857142857142857142857|8.0|  0.125|9.0|  0.111111111111111111111111|12|  0.083333333333333333333333|16|  0.0625|32|  0.03125|64|  0.015625|1.0|1.1|  0.909090909090909090909091|1.2|  0.833333333333333333333333|1.5|  0.666666666666666666666667|1.0|1.0e+1|1.0e+2|1.0e+3|1.0e+4|1.0e+5|1.0e+6|1.0e+7|1.0e+8|1.0e+9|1.0e+10|1.0e+11|1.0e+12|1.0e+13|1.0e+14|1.0e+15|1.0|1.0e-1|1.0e-2|1.0e-3|1.0e-4|1.0e-5|1.0e-6|1.0e-7|1.0e-8|1.0e-9|1.0e-10|1.0e-11|1.0e-12|1.0e-13|1.0e-14|1.0e-15|1.0"],#@djlist2 10
["Show Bbox,Center,SF|Show Bbox,Center|Show Bbox|Show Center|Show SF|ShowBlank|Small format|Large format|no read format|no|Long read out|SnapLowPrecision|SnapHighPrecision|Draw vector|Draw cpoint|no|Move to target1|Move to target1 corner|Size as target1|Move and size to target1 |Save target1|Line up to target1 Red w-side|Line up to target1 Green d-side|Line up to target1 Blue h-side|no|Move to target2|Move to target2 corner|Size as target2|Move and size to target2 |Save target2|Line up to target2 Red w-side|Line up to target2 Green d-side|Line up to target2 Blue h-side|no|scale_dj|move_dj|resize_dj|cumulativeScaler_dj|keyboardScaleGroupFloat_dj|extended_options_dj|scaleMoveResize_dj"],#@list3 11
[0.0,0.0,0.0],
[0.0,0.0,0.0],
[0.0,0.0,0.0]
]
return;end
def ScaleGroupFloatDJ.scaleGroupFloat1_dj
def initialize
ScaleGroupFloatDJ.variables_dj
return;end
if @dj_x0[4][4]=="9" or @dj_x0[4][4]=="6"or @dj_x0[4][4]=="8"or @dj_x0[4][4]=="7"or @dj_x0[4][4]=="5"then @dj_x0[4][4]="0";ScaleGroupFloatDJ.entlast_only;end;
return;end

def ScaleGroupFloatDJ.scaleGroupFloat_dj
def initialize
ScaleGroupFloatDJ.variables_dj
return;end

def ScaleGroupFloatDJ.selection_dj
dj_ss = Sketchup.active_model.selection;if !dj_ss.empty? then @dj_sents = [];dj_ss.each{|e|@dj_sents.push(e)};return;end;
ScaleGroupFloatDJ.entlast_only;dj_ss = Sketchup.active_model.selection;if !dj_ss.empty? then @dj_sents = [];dj_ss.each{|e|@dj_sents.push(e)};return;end;
ScaleGroupFloatDJ.entlast_only2;dj_ss = Sketchup.active_model.selection;if !dj_ss.empty? then @dj_sents = [];dj_ss.each{|e|@dj_sents.push(e)};return;end;
return;end;# selection_dj

def ScaleGroupFloatDJ.entlast_add
#Matt666#gnin gnin gnin#Didier#gnuff gnuff gnuff for def entlast_only
Sketchup.active_model.selection.add(Sketchup.active_model.active_entities[Sketchup.active_model.active_entities.length-1])
return;end

def ScaleGroupFloatDJ.entlast_only
#Matt666#gnin gnin gnin#Didier#gnuff gnuff gnuff for def entlast_only
Sketchup.active_model.selection.clear;Sketchup.active_model.selection.add(Sketchup.active_model.active_entities[Sketchup.active_model.active_entities.length-1])
return;end
def ScaleGroupFloatDJ.entlast_only2
#Sketchup.active_model.selection.clear;
Sketchup.active_model.selection.clear;Sketchup.active_model.selection.add(Sketchup.active_model.active_entities[Sketchup.active_model.active_entities.length-2])
return;end

def ScaleGroupFloatDJ.bBox_dj

 #___set bBox unit_____
for i in 0..33;if (@dj_x0[3][25] == @dj_x0[6][i])and (@dj_x0[3][25] != @dj_x0[4][3])then @dj_x0[5][0] = @dj_x0[8][i].to_f;@dj_x0[5][1] = @dj_x0[8][i].to_f/@dj_x0[4][0].to_f;@dj_x0[5][2] = @dj_x0[7][i].to_f;@dj_x0[4][3] = @dj_x0[3][25];end;end
#___reset bBox_____
@dj_x0[3][23]*=@dj_x0[3][22].to_f;@dj_x0[3][22]=1.0.to_f
if @dj_x0[4][4]!="5" then for i in 0..7;@dj_x0[1][i]=@dj_x0[3][i]=@dj_x0[3][i+14]=1.0;end;end;
for i in 0..5;@dj_x0[1][i+8]=@dj_x0[3][i+8]=@dj_x0[3][i+22];@dj_x0[0][i]=@dj_x0[0][i+6]=(@dj_x0[2][i]=@dj_x0[2][i+6])end

#___set bBox_____
Sketchup.active_model.start_operation "dj_Group",true,true,false
ScaleGroupFloatDJ.entlast_only
copy_group = Sketchup.active_model.active_entities.add_group(@dj_sents)
for i in 0..2;@dj_x0[2][i+3]=@dj_x0[2][i+9]=(@dj_x0[0][i+3]=@dj_x0[0][i+9]=(((copy_group.bounds.center)[i])*@dj_x0[5][0]*@dj_x0[5][2]*@dj_x0[1][9]).to_f).to_s+" "+@dj_x0[3][25].to_s;end
@dj_x0[2][6]=@dj_x0[2][0]=(@dj_x0[0][6] = @dj_x0[0][0] = (((copy_group.local_bounds.width).to_f).to_s).to_f*@dj_x0[5][0]*@dj_x0[5][2]*@dj_x0[1][9]).to_s+" "+@dj_x0[3][25].to_s 
@dj_x0[2][7]=@dj_x0[2][1]=(@dj_x0[0][7] = @dj_x0[0][1] = (((copy_group.local_bounds.height).to_f).to_s).to_f*@dj_x0[5][0]*@dj_x0[5][2]*@dj_x0[1][9]).to_s+" "+@dj_x0[3][25].to_s 
@dj_x0[2][8]=@dj_x0[2][2]=(@dj_x0[0][8] = @dj_x0[0][2] = (((copy_group.local_bounds.depth).to_f).to_s).to_f*@dj_x0[5][0]*@dj_x0[5][2]*@dj_x0[1][9]).to_s+" "+@dj_x0[3][25].to_s 
Sketchup.active_model.start_operation "dj_Group",true,true,false
copy_group.explode 

#___fix bBox range __
for i in 0..2 ;
if @dj_x0[2][i+6].to_f <= 1.0e-099 or @dj_x0[2][i+6].to_f >= 1.0e+099 then 
if @dj_x0[2][6+i].to_f <= 1.0e-099 then Sketchup.undo;@dj_x0[2][6+i]=@dj_x0[2][0+i]=(@dj_x0[0][0+i] = @dj_x0[0][6+i] = 0.0127*12.0*@dj_x0[5][0]).to_s+"*"+(@dj_x0[5][2]).to_s+"_"+@dj_x0[3][25].to_s;end 
if @dj_x0[2][6+i].to_f >= 1.0e+099 then Sketchup.undo;@dj_x0[2][6+i]=@dj_x0[2][0+i]=(@dj_x0[0][0+i] = @dj_x0[0][6+i] = 1.0*12.0*@dj_x0[5][0]).to_s+"*"+(@dj_x0[5][2]).to_s+"_"+@dj_x0[3][25].to_s;end 
@dj_x0[4][8]=@dj_x0[4][4]
#=begin
UI.messagebox(" 
Nothing was selected or your values are to small !
 
You in a error state.

Will try to select last entries.


");
#=end

ScaleGroup.undo;dj_ss = Sketchup.active_model.selection;if !dj_ss.empty? then return;end;
ScaleGroup.undo;dj_ss = Sketchup.active_model.selection;if !dj_ss.empty? then return;end;
ScaleGroup.undo;dj_ss = Sketchup.active_model.selection;if !dj_ss.empty? then return;end;
Sketchup.active_model.commit_operation
break
Sketchup.active_model.start_operation "dj_Group",true,true,false

@dj_x0[4][4]="7"
end;
end;

return;end;#bBox_dj

def ScaleGroupFloatDJ.inputbox_dj
@dj_x0[4][8]=@dj_x0[4][4]
case @dj_x0[4][4].to_s 
#scaleGroupFloat_dj
when "0" then @dj_x0[4][5]="on";@dj_x0[4][9]="on";
dj_prompts = ["scale xyz","scale xyz","w-scale (orgin axes only)","w-scale (orgin axes only)","d-scale (orgin axes only)","d-scale (orgin axes only)","z-scale (orgin axes only)","z-scale (orgin axes only)","Scale Factor","Scale Factor = in/side vol  ","w-bBox red ","d-bBox green","h-bBox blue","Outside bBox w,d,h","Unit","c-point x ","c-point y","c-point z","Outside center x,y,z","Extended options"]
dj_values = [@dj_x0[3][0],@dj_x0[3][1],@dj_x0[3][2],@dj_x0[3][3],@dj_x0[3][4],@dj_x0[3][5],@dj_x0[3][6],@dj_x0[3][7],@dj_x0[3][8],@dj_x0[3][9],@dj_x0[2][0],@dj_x0[2][1],@dj_x0[2][2],@dj_x0[3][10],@dj_x0[3][11],@dj_x0[2][3],@dj_x0[2][4],@dj_x0[2][5],@dj_x0[3][12],@dj_x0[3][13]]
dj_lists = [@dj_x0[10],"",@dj_x0[10],"",@dj_x0[10],"",@dj_x0[10],"",@dj_x0[10],"","","","","",@dj_x0[9],"","","","",@dj_x0[11]]
@results = inputbox dj_prompts,dj_values,dj_lists,"scaleGroupFloat_dj  ( local and orgin axes )"
if not @results then Sketchup.active_model.commit_operation;return;end
@dj_x0[3][14],@dj_x0[3][15],@dj_x0[3][16],@dj_x0[3][17],@dj_x0[3][18],@dj_x0[3][19],@dj_x0[3][20],@dj_x0[3][21],@dj_x0[3][22],@dj_x0[3][23],@dj_x0[2][6],@dj_x0[2][7],@dj_x0[2][8],@dj_x0[3][24],@dj_x0[3][25],@dj_x0[2][9],@dj_x0[2][10],@dj_x0[2][11],@dj_x0[3][26],@dj_x0[3][27] = @results
#keyboardGroupFloat_dj
when "1" then @dj_x0[4][5]="on";@dj_x0[4][9]="on";
dj_prompts = ["Scale xyz","Scale width.red (orgin axes)","Scale depth.green (orgin axes)","Scale hight.blue (orgin axes)","Scale Factor = inside/outside vol  ","Inside bBox width.red ","Inside bBox depth.green","Inside bBox hight.blue","Group bb-dimension w,d,h ","Unit","Inside bBox c-point x","Inside bBox c-point y","Inside bBox c-point z","Outside bBox center x,y,z ","Extended options"]
dj_values = [@dj_x0[3][1],@dj_x0[3][3],@dj_x0[3][5],@dj_x0[3][7],@dj_x0[3][9],@dj_x0[2][0],@dj_x0[2][1],@dj_x0[2][2],@dj_x0[3][10],@dj_x0[3][11],@dj_x0[2][3],@dj_x0[2][4],@dj_x0[2][5],@dj_x0[3][12],@dj_x0[3][13]]
dj_lists = ["","","","","","","","","",@dj_x0[9],"","","","",@dj_x0[11]]
@results = inputbox dj_prompts,dj_values,dj_lists,"keyboard_dj  ( local and orgin axes )"
if not @results then Sketchup.active_model.commit_operation;return;end
@dj_x0[3][15],@dj_x0[3][17],@dj_x0[3][19],@dj_x0[3][21],@dj_x0[3][23],@dj_x0[2][6],@dj_x0[2][7],@dj_x0[2][8],@dj_x0[3][24],@dj_x0[3][25],@dj_x0[2][9],@dj_x0[2][10],@dj_x0[2][11],@dj_x0[3][26],@dj_x0[3][27] = @results
#move_dj
when "2" then @dj_x0[4][5]="on";@dj_x0[4][9]="on";
dj_prompts = ["Inside bBox c-point x","Inside bBox c-point y","Inside bBox c-point z","Extended options" ]
dj_values = [@dj_x0[2][3],@dj_x0[2][4],@dj_x0[2][5],@dj_x0[3][13]]
dj_lists = ["","","",@dj_x0[11]]
@results = inputbox dj_prompts,dj_values,dj_lists,"move_dj  ( local and orgin axes )"
if not @results then Sketchup.active_model.commit_operation;return;end
@dj_x0[2][9],@dj_x0[2][10],@dj_x0[2][11],@dj_x0[3][27] = @results
#ScaleGroupFloat_dj
when "3" then @dj_x0[4][5]="on";@dj_x0[4][9]="on";
dj_prompts = ["Scale xyz","Scale width.red (orgin axes)","Scale depth.green (orgin axes)","Scale hight.blue (orgin axes)","Scale Factor = inside/outside vol  ","Extended options"]
dj_values = [@dj_x0[3][1],@dj_x0[3][3],@dj_x0[3][5],@dj_x0[3][7],@dj_x0[3][9],@dj_x0[3][13]]
dj_lists = ["","","","","",@dj_x0[11]]
@results = inputbox dj_prompts,dj_values,dj_lists,"scale_dj  ( local and orgin axes )"
if not @results then Sketchup.active_model.commit_operation;end
  @dj_x0[3][15],@dj_x0[3][17],@dj_x0[3][19],@dj_x0[3][21],@dj_x0[3][23],@dj_x0[3][27] = @results
#resize_dj
when "4" then @dj_x0[4][5]="on";@dj_x0[4][9]="on";
dj_prompts = ["Inside bBox width.red","Inside bBox depth.green","Inside bBox hight.blue","Unit","Extended options"]
dj_values = [@dj_x0[2][0],@dj_x0[2][1],@dj_x0[2][2],@dj_x0[3][11],@dj_x0[3][13]]
dj_lists = ["","","",@dj_x0[9],@dj_x0[11]]
@results = inputbox dj_prompts,dj_values,dj_lists,"resize_dj  ( local and orgin axes )"
if not @results then Sketchup.active_model.commit_operation;return;end
  @dj_x0[2][6],@dj_x0[2][7],@dj_x0[2][8],@dj_x0[3][25],@dj_x0[3][27] = @results

when "5" then
# int:Save target1

ScaleGroupFloatDJ.entlast_only;
@dj_x0[3][27]="Save target1";
ScaleGroupFloatDJ.target_dj;
@dj_x0[3][27]="Save target1";
# :Add  to the model.
Sketchup.send_action(57634);ScaleGroupFloatDJ.entlast_only;for i in 0..2;@dj_x0[2][i+9]=@dj_x0[5][i+9];end;Sketchup.send_action(21939);ScaleGroupFloatDJ.entlast_only
for i in 0..2;@dj_x0[2][i+9]=@dj_x0[5][i+9];end
for i in 0..3 ; @dj_x0[1][1+i*2]=@dj_x0[3][1+i*2]=(@dj_x0[3][15+i*2]*=@dj_x0[3][14+i*2]);@dj_x0[1][i*2]=@dj_x0[3][i*2]=@dj_x0[3][14+i*2]=1.0;end
@dj_x0[4][5]="on";
#loop
for j in 0..100
Sketchup.send_action("selectMoveTool:")
@dj_x0[4][5]="on";@dj_x0[4][4]="5"
#box +
dj_prompts = ["Quick scale xyz","Scale xyz","Quick scale w.r (orgin axes)","Scale width.red (orgin axes)","Quick scale d.g (orgin axes)","Scale depth.green (orgin axes)","Quick scale h.b (orgin axes)","Scale hight.blue (orgin axes)","Quick Scale Factor","Scale Factor = inside/outside vol  ","Inside bBox width.red ","Inside bBox depth.green","Inside bBox hight.blue","step w","step d","step h","Outside bBox dimension w,d,h","Unit","Inside bBox c-point x","Inside bBox c-point y","Inside bBox c-point z","step x","step y","step z","Outside bBox center x,y,z","x-axis rotation (deg)","y-axis rotation (deg)","z-axis rotation (deg)","Extended options"]
dj_values = [@dj_x0[3][0],@dj_x0[3][1],@dj_x0[3][2],@dj_x0[3][3],@dj_x0[3][4],@dj_x0[3][5],@dj_x0[3][6],@dj_x0[3][7],@dj_x0[3][8],@dj_x0[3][9],@dj_x0[2][0],@dj_x0[2][1],@dj_x0[2][2],@dj_x0[12][0],@dj_x0[12][1],@dj_x0[12][2],@dj_x0[3][10],@dj_x0[3][11],@dj_x0[2][3],@dj_x0[2][4],@dj_x0[2][5],@dj_x0[13][0],@dj_x0[13][1],@dj_x0[13][2],@dj_x0[3][12],@dj_x0[14][0],@dj_x0[14][1],@dj_x0[14][2],@dj_x0[3][13]]
dj_lists = [@dj_x0[10],"",@dj_x0[10],"",@dj_x0[10],"",@dj_x0[10],"",@dj_x0[10],"","","","","","","","",@dj_x0[9],"","","","","","","","","","",@dj_x0[11]]
@results = inputbox dj_prompts,dj_values,dj_lists,"cumulativeScaler_dj( local and orgin axes )"
if not @results then Sketchup.active_model.start_operation "dj_Group",true,true,true;Sketchup.undo;Sketchup.send_action(21021);Sketchup.send_action(21939);Sketchup.active_model.commit_operation;
;Sketchup.send_action("selectSelectionTool:");return;end
@dj_x0[3][14],@dj_x0[3][15],@dj_x0[3][16],@dj_x0[3][17],@dj_x0[3][18],@dj_x0[3][19],@dj_x0[3][20],@dj_x0[3][21],@dj_x0[3][22],@dj_x0[3][23],@dj_x0[2][6],@dj_x0[2][7],@dj_x0[2][8],@dj_x0[12][0],@dj_x0[12][1],@dj_x0[12][2],@dj_x0[3][24],@dj_x0[3][25],@dj_x0[2][9],@dj_x0[2][10],@dj_x0[2][11],@dj_x0[13][0],@dj_x0[13][1],@dj_x0[13][2],@dj_x0[3][26],@dj_x0[14][0],@dj_x0[14][1],@dj_x0[14][2],@dj_x0[3][27] = @results
#post box set
for i in 0..3 ; @dj_x0[1][1+i*2]=@dj_x0[3][1+i*2]=(@dj_x0[3][15+i*2]*=@dj_x0[3][14+i*2]);@dj_x0[1][i*2]=@dj_x0[3][i*2]=@dj_x0[3][14+i*2]=1.0;end
@dj_x0[2][6]=(@dj_x0[2][6].to_f+@dj_x0[12][0].to_f).to_s;@dj_x0[2][7]=(@dj_x0[2][7].to_f+@dj_x0[12][1].to_f).to_s;@dj_x0[2][8]=(@dj_x0[2][8].to_f+@dj_x0[12][2].to_f).to_s;@dj_x0[2][9]=(@dj_x0[2][9].to_f+@dj_x0[13][0].to_f).to_s;@dj_x0[2][10]=(@dj_x0[2][10].to_f+@dj_x0[13][1].to_f).to_s;@dj_x0[2][11]=(@dj_x0[2][11].to_f+@dj_x0[13][2].to_f).to_s;
#box - 

#pre scaleGroupFloat calls
@dj_x0[4][5]="on";Sketchup.send_action(57634);ScaleGroupFloatDJ.entlast_only2;@dj_x0[3][27]="Save target1";
# scaleGroupFloat calls
ScaleGroupFloatDJ.target_dj;

ScaleGroupFloatDJ.move1_dj;
Sketchup.send_action("selectMoveTool:")
ScaleGroupFloatDJ.scale_dj;
for i in 0..2;@dj_x0[2][i+9]=(@dj_x0[5][i+9].to_f+(@dj_x0[13][i].to_s.to_f)).to_s;end
Sketchup.send_action("selectMoveTool:")
ScaleGroupFloatDJ.bBox_dj
#post scaleGroupFloat set 
ScaleGroupFloatDJ.entlast_only;Sketchup.send_action(21939);ScaleGroupFloatDJ.entlast_only;
# move target1
for i in 0..2;@dj_x0[2][i+9]=@dj_x0[5][i+9];end
end

#Extended options_dj
when "6" then 
dj_prompts = ["Extended options"]
dj_values = [@dj_x0[3][27].to_s]
dj_lists = [@dj_x0[11]]
@results = inputbox dj_prompts,dj_values,dj_lists,"Extend_dj  ( local and orgin axes )"
if not @results then Sketchup.active_model.commit_operation;return;end
@dj_x0[3][27]= @results
#pass
when "7" then ScaleGroupFloatDJ.entlast_only;@dj_x0[4][5]="off";
ScaleGroupFloatDJ.bBox_dj;
#pass
when "8" then ScaleGroupFloatDJ.entlast_only;@dj_x0[4][5]="off";
ScaleGroupFloatDJ.bBox_dj
when "9" then @dj_x0[4][5]="off";

#pass
when "10" then @dj_x0[4][5]="on";

end;#case
return;end;#input_dj

def ScaleGroupFloatDJ.target_dj
#___ target 
case @dj_x0[3][27].to_s
when "Save target1" then for i in 0..5 ;@dj_x0[5][i+6] =@dj_x0[2][i+6];end;@dj_x0[3][27] = "no";ScaleGroupFloatDJ.entlast_only;
when "Save target2" then for i in 0..5 ;@dj_x0[5][i+12]=@dj_x0[2][i+6];end;@dj_x0[3][27] = "no";ScaleGroupFloatDJ.entlast_only;
when "Move and size to target1 " then for i in 0..5 ;@dj_x0[2][i+6] =@dj_x0[5][i+6];end;@dj_x0[3][27] = "no"
when "Move and size to target2 " then for i in 0..5 ;@dj_x0[2][i+6] =@dj_x0[5][i+12];end;@dj_x0[3][27] = "no"
when "Size as target1" then for i in 0..2 ;@dj_x0[2][i+6] =@dj_x0[5][i+6];end;@dj_x0[3][27] = "no"
when "Size as target2" then for i in 0..2 ;@dj_x0[2][i+6] =@dj_x0[5][i+12];end;@dj_x0[3][27] = "no"
when "Move to target1" then for i in 0..2 ;@dj_x0[2][i+9] =@dj_x0[5][i+9];end;@dj_x0[3][27] = "no"
when "Move to target2" then for i in 0..2 ;@dj_x0[2][i+9] =@dj_x0[5][i+15];end;@dj_x0[3][27] = "no"
when "Line up to target1 Red w-side" then for i in 0..2;@dj_x0[2][i+9] = @dj_x0[5][i+9];@dj_x0[2][10] =0.0.to_s;end;@dj_x0[3][27] = "no";ScaleGroupFloatDJ.entlast_only;
when "Line up to target1 Blue h-side" then for i in 0..2;@dj_x0[2][i+9] = @dj_x0[5][i+9];@dj_x0[2][11] =0.0.to_s;end;@dj_x0[3][27] = "no";ScaleGroupFloatDJ.entlast_only;
when "Line up to target1 Green d-side" then for i in 0..2;@dj_x0[2][i+9] = @dj_x0[5][i+9];@dj_x0[2][9] =0.0.to_s;end;@dj_x0[3][27] = "no";ScaleGroupFloatDJ.entlast_only;
when "Line up to target2 Red w-side" then for i in 0..2;@dj_x0[2][i+9] = @dj_x0[5][i+15];@dj_x0[2][16] =0.0.to_s;end;@dj_x0[3][27] = "no";ScaleGroupFloatDJ.entlast_only;
when "Line up to target2 Blue h-side" then for i in 0..2;@dj_x0[2][i+9] = @dj_x0[5][i+15];@dj_x0[2][17] =0.0.to_s;end;@dj_x0[3][27] = "no";ScaleGroupFloatDJ.entlast_only;
when "Line up to target2 Green d-side" then for i in 0..2;@dj_x0[2][i+9] = @dj_x0[5][i+15];@dj_x0[2][15] =0.0.to_s;end;@dj_x0[3][27] = "no";ScaleGroupFloatDJ.entlast_only;
when "Move to target1 corner" then ;for i in 0..2 ;@dj_x0[2][i+9] = (@dj_x0[5][i+9].to_f + (@dj_x0[5][i+6].to_f/2.0) + (@dj_x0[2][i+6].to_f/2.0)).to_s;end;ScaleGroupFloatDJ.entlast_only;@dj_x0[3][27] = "no"
when "Move to target2 corner" then ;for i in 0..2 ;@dj_x0[2][i+9] = (@dj_x0[5][i+15].to_f + (@dj_x0[5][i+12].to_f/2.0) + (@dj_x0[2][i+6].to_f/2.0)).to_s;end;ScaleGroupFloatDJ.entlast_only;@dj_x0[3][27] = "no"
#___ text format
when "Small format" then @dj_x0[4][6] ="0.5";#@dj_x0[4][7] = "Show Bbox,Center"
when "Large format" then @dj_x0[4][6] ="1.0";#@dj_x0[4][7] = "Show Bbox,Center"
when "no read format" then @dj_x0[4][6] ="0.0";@dj_x0[4][7]=="ShowBlank"
#___ inputbox
when "scaleMoveResize_dj" then @dj_x0[4][8]=@dj_x0[4][4]="0";
when "keyboardScaleGroupFloat_dj" then @dj_x0[4][8]=@dj_x0[4][4]="1";
when "move_dj" then @dj_x0[4][8]=@dj_x0[4][4]="2";
when "scale_dj" then @dj_x0[4][8]=@dj_x0[4][4]="3";
when "resize_dj" then @dj_x0[4][8]=@dj_x0[4][4]="4";
when "cumulativeScaler_dj" then @dj_x0[4][8]=@dj_x0[4][4]="5";
when "extended_options_dj" then @dj_x0[4][8]=@dj_x0[4][4]="6";
end;#case
return;end;#target_dj

def ScaleGroupFloatDJ.move_dj
#move!
if @dj_x0[4][9]=="on" then
Sketchup.active_model.start_operation "dj_Group",true,true,false
copy_group = Sketchup.active_model.active_entities.add_group(@dj_sents)
# Thanks sdmitch solved by sdmitch on Thu May 17, 2012 1:48 pm-group.move!
copy_group.move! Geom::Transformation.new Geom::Point3d.new @dj_x0[2][9].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0].to_f-(@dj_x0[2][0].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0]/2.0).to_f,@dj_x0[2][10].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0].to_f-(@dj_x0[2][1].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0]/2.0).to_f,@dj_x0[2][11].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0].to_f-(@dj_x0[2][2].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0]/2.0).to_f
Sketchup.active_model.start_operation "dj_Group",true,true,false
copy_group.explode
@dj_x0[4][9]="on";
end
return;end;#move_dj

def ScaleGroupFloatDJ.move1_dj
#move!
if @dj_x0[4][9]=="on" then
Sketchup.active_model.start_operation "dj_Group",true,true,false
copy_group = Sketchup.active_model.active_entities.add_group(@dj_sents)

# Thanks sdmitch solved by sdmitch on Thu May 17, 2012 1:48 pm-group.move!
copy_group.move! Geom::Transformation.new Geom::Point3d.new @dj_x0[2][9].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0].to_f-(@dj_x0[2][0].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0]/2.0).to_f,@dj_x0[2][10].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0].to_f-(@dj_x0[2][1].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0]/2.0).to_f,@dj_x0[2][11].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0].to_f-(@dj_x0[2][2].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0]/2.0).to_f
Sketchup.active_model.start_operation "dj_Group",true,true,false
copy_group.transform! Geom::Transformation.rotation copy_group.bounds.center, copy_group.transformation.xaxis, @dj_x0[14][0].degrees
copy_group.transform! Geom::Transformation.rotation copy_group.bounds.center, copy_group.transformation.yaxis, @dj_x0[14][1].degrees
copy_group.transform! Geom::Transformation.rotation copy_group.bounds.center, copy_group.transformation.zaxis, @dj_x0[14][2].degrees
copy_group.explode
@dj_x0[4][9]="on";
end
return;end;#move_dj

def ScaleGroupFloatDJ.scale_dj
#scale
Sketchup.active_model.start_operation "dj_Group",true,true,false
copy_group = Sketchup.active_model.active_entities.add_group(@dj_sents)
for i in 0..2;@dj_x0[5][i+3]=(@dj_x0[3][14]*@dj_x0[3][15]*@dj_x0[3][i*2+16]*@dj_x0[3][i*2+17]*@dj_x0[2][i+6].to_f/@dj_x0[2][i].to_f);end
copy_group.transform!(Geom::Transformation.scaling(copy_group.bounds.center,@dj_x0[5][3].to_f,@dj_x0[5][4].to_f,@dj_x0[5][5].to_f))
Sketchup.active_model.start_operation "dj_Group",true,true,false
copy_group.explode
return;end; #scale_dj

def ScaleGroupFloatDJ.step_dj
#steppng undo
Sketchup.active_model.start_operation "dj_Group",true,true,false
copy_group = Sketchup.active_model.active_entities.add_group(@dj_sents)
Sketchup.active_model.start_operation "dj_Group",true,false,false
copy_group.explode
return;end;#step_dj

def ScaleGroupFloatDJ.readout_dj
@dj_x0[3][27]=@dj_x0[3][27].to_s
# readout
@dj_x0[3][24] = " Bbox [w,d,h] ["+(@dj_x0[2][6].to_f).to_s+" "+@dj_x0[3][25]+", "+(@dj_x0[2][7].to_f).to_s+" "+@dj_x0[3][25]+", "+(@dj_x0[2][8].to_f).to_s+" "+@dj_x0[3][25]+"] ";;@dj_x0[3][26]= " Center (xyz) ("+(@dj_x0[2][9].to_f).to_s+" "+@dj_x0[3][25]+", "+(@dj_x0[2][10].to_f).to_s+" "+@dj_x0[3][25]+", "+(@dj_x0[2][11].to_f).to_s+" "+@dj_x0[3][25]+") "
# Thanks TiG solved by TIG on Fri Jun 01, 2012 6:35 am-e.erase!
Sketchup.active_model.active_entities.to_a.each{|e|;e.erase! if e.is_a?(Sketchup::Text) and e.point==Geom::Point3d.new(@dj_x0[2][9].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][10].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9],@dj_x0[2][11].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9])}
if @dj_x0[4][6]=="0.5" then @dj_x0[3][24] = " ["+(@dj_x0[2][6].to_f).to_s+", "+(@dj_x0[2][7].to_f).to_s+", "+(@dj_x0[2][8].to_f).to_s+"]"+" "+@dj_x0[3][25]+"  ";;@dj_x0[3][26]= " ("+(@dj_x0[2][9].to_f).to_s+", "+(@dj_x0[2][10].to_f).to_s+", "+(@dj_x0[2][11].to_f).to_s+")"+" "+@dj_x0[3][25]+"  ";end
if @dj_x0[4][6]=="1,0" then @dj_x0[3][24] = ["Bbox(w,d,h) ("+@dj_x0[2][6].to_f.to_s+"_"+@dj_x0[3][25]+", ",(@dj_x0[2][7].to_f).to_s+"_"+@dj_x0[3][25]+", ",(@dj_x0[2][8].to_f).to_s+"_"+@dj_x0[3][25]+")"].to_s;;@dj_x0[3][26] = ["Bbox(w,d,h) ("+@dj_x0[2][9].to_f.to_s+"_"+@dj_x0[3][25]+", ",(@dj_x0[2][10].to_f).to_s+"_"+@dj_x0[3][25]+", ",(@dj_x0[2][11].to_f).to_s+"_"+@dj_x0[3][25]+")"].to_s;end
if @dj_x0[4][6]!="0.0" then 
if @dj_x0[4][7]=="Show Bbox,Center,SF" or @dj_x0[3][27]=="Show Bbox,Center,SF" then Sketchup.active_model.entities.add_text @dj_x0[3][24].to_s+"\n"+@dj_x0[3][26].to_s+"\n SF = "+@dj_x0[3][23].to_s,(Geom::Point3d.new([@dj_x0[2][9].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][10].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][11].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9]]));@dj_x0[4][7]="Show Bbox,Center,SF";end
if @dj_x0[4][7]=="Show Bbox,Center" or @dj_x0[3][27]=="Show Bbox,Center" then Sketchup.active_model.entities.add_text @dj_x0[3][24].to_s+"\n"+@dj_x0[3][26].to_s,(Geom::Point3d.new([@dj_x0[2][9].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][10].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][11].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9]]));@dj_x0[4][7]="Show Bbox,Center";end
if @dj_x0[4][7]=="Show Bbox" or @dj_x0[3][27]=="Show Bbox" then Sketchup.active_model.entities.add_text @dj_x0[3][24].to_s,(Geom::Point3d.new([@dj_x0[2][9].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][10].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][11].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9]]));@dj_x0[4][7]="Show Bbox";end
if @dj_x0[4][7]=="Show Center" or @dj_x0[3][27]=="Show Center" then Sketchup.active_model.entities.add_text @dj_x0[3][26].to_s,(Geom::Point3d.new([@dj_x0[2][9].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][10].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][11].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9]]));@dj_x0[4][7]="Bbox,Center";end
if @dj_x0[4][7]=="Show SF" or @dj_x0[3][27]=="Show SF" then Sketchup.active_model.entities.add_text "\n SF = "+@dj_x0[3][23].to_s,(Geom::Point3d.new([@dj_x0[2][9].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][10].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][11].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9]]));@dj_x0[4][7]="Show SF";end
end;#if
if @dj_x0[4][7]=="ShowBlank" or @dj_x0[3][27]=="ShowBlank" then Sketchup.active_model.entities.add_text "",(Geom::Point3d.new([@dj_x0[2][9].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][10].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][11].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9]]));@dj_x0[4][7]="ShowBlank";end
#___ Outside = Inside 
@dj_x0[3][24] = @dj_x0[3][26] = "Outside = Inside".to_s
if @dj_x0[3][23] !=1.0 or @dj_x0[3][27].to_s=="Long read out" then @dj_x0[3][24] = " Bbox [w,d,h] ["+(@dj_x0[2][6].to_f/@dj_x0[1][9].to_f).to_s+" "+@dj_x0[3][25]+", "+(@dj_x0[2][7].to_f/@dj_x0[1][9].to_f).to_s+" "+@dj_x0[3][25]+", "+(@dj_x0[2][8].to_f/@dj_x0[1][9].to_f).to_s+" "+@dj_x0[3][25]+"] ";;@dj_x0[3][26]= " Center (x,y,z) ("+(@dj_x0[2][9].to_f/@dj_x0[1][9].to_f).to_s+" "+@dj_x0[3][25]+", "+(@dj_x0[2][10].to_f/@dj_x0[1][9].to_f).to_s+" "+@dj_x0[3][25]+", "+(@dj_x0[2][11].to_f/@dj_x0[1][9].to_f).to_s+" "+@dj_x0[3][25]+") ";end;#if blank
#___case
case @dj_x0[3][27].to_s
#__draw ____
when "Draw vector" then Sketchup.active_model.entities.add_line([0,0,0],[@dj_x0[0][9]/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9],@dj_x0[0][10]/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9],@dj_x0[0][11]/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9]]);@dj_x0[3][27] = "no";
when "Draw cpoint" then Sketchup.active_model.active_entities.add_cpoint(Geom::Point3d.new(@dj_x0[0][9]/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9],@dj_x0[0][10]/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9],@dj_x0[0][11]/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9]));@dj_x0[3][27] = "no";
#__Snap____
when "SnapHighPrecision" then Sketchup.write_default "Preferences","SnapAngle",1.000000000000000e-40;Sketchup.write_default "Preferences","SnapLength",1.0000000000000000e-34;@dj_x0[3][27] = "no"
when "SnapLowPrecision" then Sketchup.write_default "Preferences","SnapAngle",1.0;Sketchup.write_default "Preferences","SnapLength",0.000;@dj_x0[16] = "no";
end;#case
return;end;#readout_dj
#================================================================

Sketchup.active_model.start_operation "dj_Group",true,true,false

ScaleGroupFloatDJ.selection_dj

Sketchup.active_model.start_operation "dj_Group",true,true,false

for i in 0..100
ScaleGroupFloatDJ.bBox_dj
if @dj_x0[4][4]=="8" and @dj_x0[4][7]=="ShowBlank" then @dj_x0[3][27]="Show Bbox,Center";end
if @dj_x0[4][4]=="8" and @dj_x0[3][27]=="ShowBlank" then @dj_x0[3][27]="ShowBlank";end
ScaleGroupFloatDJ.inputbox_dj
ScaleGroupFloatDJ.target_dj
if (not @results)then ScaleGroupFloatDJ.entlast_only;for i in 0..5;@dj_x0[3][i+14]=@dj_x0[3][i+16]=1.0;@dj_x0[3][i+22]=@dj_x0[3][i+8];@dj_x0[1][9]=1.0;end;ScaleGroupFloatDJ.entlast_only;Sketchup.active_model.commit_operation;return;end
if @dj_x0[4][4]!="8" then ScaleGroupFloatDJ.readout_dj;end
ScaleGroupFloatDJ.move_dj
ScaleGroupFloatDJ.scale_dj
ScaleGroupFloatDJ.bBox_dj
ScaleGroupFloatDJ.readout_dj
ScaleGroupFloatDJ.step_dj
if(not @results) || (@dj_x0[4][5]=="off") then for i in 0..5;@dj_x0[3][i+14]=@dj_x0[3][i+16]=1.0;@dj_x0[3][i+22]=@dj_x0[3][i+8];end;;Sketchup.active_model.commit_operation;return;end
Sketchup.send_action "selectSelectionTool:"
Sketchup.active_model.commit_operation
end;#for100 

if @dj_x0[4][4]=5 then @dj_x0[4][4]=0;end

if !@dj_x0[4][4]=="8" then ScaleGroupFloatDJ.entlast_only;end

Sketchup.active_model.entities.add_text "".to_s,(Geom::Point3d.new([@dj_x0[2][9].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][10].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9], @dj_x0[2][11].to_f/@dj_x0[5][0]/@dj_x0[5][2]/@dj_x0[1][9]]))

Sketchup.active_model.start_operation "dj_Group",true,true,true

ScaleGroupFloatDJ.readout_dj
Sketchup.active_model.commit_operation
ScaleGroupFloatDJ.entlast_only2
Sketchup.send_action("selectSelectionTool:");
end;#  ScaleGroupFloatDJ.scaleGroupFloat_dj

def ScaleGroupFloatDJ.repeatUndoTool_dj
#def initialize
#ScaleGroupFloatDJ.variables_dj
#return;end
#prepbox
dj_list=["0|1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30"]
dj_list1=["0|10|20|30|40|50|60|70|80|90"]
dj_list2=["undo|redo|copy_to_undo|copy_to_redo|paste-in-place_undo"]
#inputbox
dj_prompts = ["Repeat by tens and ","Repeat by ones","Undo tools ","sketchup fix maxium number of undo's"]
dj_values = [@dj_x0[5][21],@dj_x0[5][22],@dj_x0[5][23],@dj_x0[5][24]]
dj_lists = [dj_list1,dj_list,dj_list2,""]
@results = inputbox dj_prompts, dj_values, dj_lists, "repeatUndoTool_dj"
if not @results then return;end 
@dj_x0[5][21],@dj_x0[5][22],@dj_x0[5][23],@dj_x0[5][24] = @results
#set
dj_count = (@dj_x0[5][21].to_f+@dj_x0[5][22].to_f)
#action
if @dj_x0[5][23].to_s=="paste-in-place_undo" then Sketchup.send_action(21939);@dj_x0[5][23].to_s="copy_to_undo";end
if @dj_x0[5][23].to_s=="copy_to_undo" then 
Sketchup.send_action 21101;Sketchup.send_action(57634);for i in 0...dj_count;Sketchup.send_action "editUndo:";end;Sketchup.send_action 21101;Sketchup.send_action 21021;Sketchup.send_action(21939);end;
if @dj_x0[5][23].to_s=="undo" then for i in 0...dj_count;Sketchup.send_action "editUndo:";Sketchup.active_model.commit_operation;end;end
if @dj_x0[5][23].to_s=="copy_to_redo" then Sketchup.send_action 21101;Sketchup.send_action(57634);for i in 0...dj_count;Sketchup.send_action "editRedo:";end;Sketchup.send_action 21101;Sketchup.send_action 21021;Sketchup.send_action(21939);end;
if @dj_x0[5][23].to_s=="redo" then for i in 0...dj_count;Sketchup.send_action "editRedo:";end;end
if @dj_x0[5][24].to_f >= 0 then @dj_x0[5][24] = @dj_x0[5][24].to_i;Sketchup.write_default "Preferences", "MaxUndo", @dj_x0[5][24];end
return;end

def ScaleGroupFloatDJ.listingScaleGroupFloat_dj

dj_entity = []
dj_entity[0] = "List of features for scaleGroupFloat_dj  ".to_s

#inputbox
lis=[dj_entity[0],"|","Group scaling tool for objects, scales along XYZ axes.|Drop down menu's for quick and easy use of X, Y, Z, XYZ|Scale factor for oversize or undesize objects|Group move tool for objects|Group resize tool for objects|Cumulative dolling|Local and orgin axes mode|Muli inputbox mode for easy to view|Converts units|2 box readouts and 2 drawing readouts (small and large) |show a vector between local and orgin axes|shows a center points of sected object|extened option|2 levels of target saves|2 levels of target move to center of object|2 levels of target move and size|2 levels of target resize to objects|2 levels of line up side to axes|2 levels to move to corner of a object|Lots of readout formats|drawBoxPoint_dj to set up target moves inside and outside of objects|repeatUndoTool_dj to move through the undo's|Two target tool buttons for move and save|It's gives high precision float values|Can create a scale factor for regional space|Can create cumulativeScaler objects by stepping rotating and moving|cumulativeScaler_dj move around (a step boxpoint)|cumulativeScaler_dj size leanear stepper|cumulativeScaler_dj move leanear stepper"]

#inputbox
prompts = ["My features"]
values = [dj_entity[0]]
lists = [lis.to_s]
#inputbox
@results = inputbox prompts, values, lists, "features_dj v1.6"
if not @results then return;end 
@dj_entity[0] = @results
return;end
#================================================================
def ScaleGroupFloatDJ.cumulativejob_dj
Sketchup.active_model.start_operation "dj_Group",true,false,true
@dj_x0[4][4]="5";@dj_x0[3][27]="no";
@dj_x0[4][5]="on";@dj_x0[4][9]="on";
@dj_x0[3][27]="cumulativeScaler_dj";
ScaleGroupFloatDJ.scaleGroupFloat_dj
Sketchup.active_model.start_operation "dj_Group",true,true,true
Sketchup.active_model.commit_operation
return;end

def ScaleGroupFloatDJ.save_target1_dj
Sketchup.active_model.start_operation "dj_Group",true,true,true
@dj_x0[4][8]=@dj_x0[4][4];
@dj_x0[4][4]="6";@dj_x0[4][9]="off";@dj_x0[4][6] ="0.0";
@dj_x0[3][27]="Save target1";
@dj_x0[4][5]="off";
ScaleGroupFloatDJ.scaleGroupFloat_dj
Sketchup.active_model.start_operation "dj_Group",true,true,true
Sketchup.active_model.commit_operation
@dj_x0[4][9]="on";
return;end

def ScaleGroupFloatDJ.move_to_target1_dj
Sketchup.active_model.start_operation "dj_Group",true,true,false
if @dj_x0[4][4]!="9" then @dj_x0[4][4]="6";end 
@dj_x0[4][5]="off";@dj_x0[4][9]="on";@dj_x0[4][6] ="0.0";@dj_x0[3][27]="Move to target1";
ScaleGroupFloatDJ.scaleGroupFloat_dj;
Sketchup.active_model.start_operation "dj_Group",true,true,false
Sketchup.active_model.commit_operation
@dj_x0[4][4]="9";
return;end

def ScaleGroupFloatDJ.read_bbox_dj
@dj_x0[4][5]="off";@dj_x0[4][9]="0ff";
if @dj_x0[4][4]!="8" then @dj_x0[4][4]="6";@dj_x0[3][27]="Show Bbox,Center";@dj_x0[4][6] ="0.5";end
ScaleGroupFloatDJ.scaleGroupFloat_dj;
Sketchup.active_model.commit_operation
@dj_x0[4][4]="8";@dj_x0[4][9]="on";
return;end


class ScaleGroupFloatDJ::DrawBoxPointDJ 

def initialize
@dj_x0 = [
[1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0],#bbox (size,xyz,c) 0
[1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,"Outside = Inside","ft","Outside = Inside","no"],#bbox(scale,info) 1
["1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0","1.0",1.0],#inputbox in/out bbox(size,xyz,c) 2
[1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,"Outside = Inside","ft","Outside = Inside","no",1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,"Outside = Inside","ft","Outside = Inside","no"],#inputbox in/out scale 3
[39.370078740157480314960629921260,0.02540,"ft","in","0","off","1.0","ShowBlank","1.0","1.0"],#cc,#data(units),switch 4 
[1.0,1.0,1.0,1.0,1.0,1.0,"w1","d1","h1","x1","y1","z1","w2","d2","h2","x2","y2","z2",0.0127,0.0127,0.0127,"90","10","undo",100],# data(scale),save 1&2 bbox(),drawBoxPoint() 5
["thou","in","ft","cubit","yd","rod","furlong","mi","Ym","Zm","Em","Pm","Tm","Gm","Mm","km","hm","dam","m","dm","cm","mm","um","nm","Angstrom","pm","am","fm","zm","ym","x?","quintillionth","y?","planckto"],# dj_unit 6
[(1.0),(1.0),(1.0),(1.0),(1.0),(1.0),(1.0),(1.0),(1000.0e-21),(1000.0e-18),(1000.0e-15),(1000.0e-12),(1000.0e-9),(1000.0e-6),(1000.0e-3),(1000.0e-0),(100.0e-0),(10.0e-0),(1.0e-0),(10.0e+0),(100.0e+0),(1000.0e+0),(1000.0e+3),(1000.0e+6),(1000.0e+7),(1000.0e+9),(1000.0e+12),(1000.0e+15),(1000.0e+18),(1000.0e+21),(1000.0e+24),(1000.0e+27),(1000.0e+30),(1000.0e+31)],#"con" data 7
[(1000.0),(1.0/1.0),(1.0/12),(1.0/18.0),(1.0/36),(1.0/240),(1.0/7920),(1.0/63360.0),0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254,0.0254],#"con" data 8
["thou|in|ft|cubit|yd|rod|furlong|mi|Ym|Zm|Em|Pm|Tm|Gm|Mm|km|hm|dam|m|dm|cm|mm|um|nm|Angstrom|pm|am|fm|zm|ym|x?|quintillionth|y?|planckto"],#@list1_9
["1.0|2.0|  0.5|3.0|  0.333333333333333333333333|4.0|  0.25|5.0|  0.2|6.0|  0.166666666666666666666667|7.0|  0.142857142857142857142857|8.0|0.125|9.0|  0.111111111111111111111111|12|  0.083333333333333333333333|16|  0.0625|32|  0.03125|64|  0.015625|1.0|1.0e+1|1.0e+2|1.0e+3|1.0e+4|1.0e+5|1.0e+6|1.0e+7|1.0e+8|1.0e+9|1.0e+10|1.0e+11|1.0e+12|1.0e+13|1.0e+14|1.0e+15|1.0|1.0e-1|1.0e-2|1.0e-3|1.0e-4|1.0e-5|1.0e-6|1.0e-7|1.0e-8|1.0e-9|1.0e-10|1.0e-11|1.0e-12|1.0e-13|1.0e-14|1.0e-15|1.0"],#@djlist2 10
["Show Bbox,Center,SF|Show Bbox,Center|Show Bbox|Show Center|Show SF|ShowBlank|Small format|Large format|no|Long read out|SnapLowPrecision|SnapHighPrecision|Draw vector|Draw cpoint|no|Move to target1|Move to target1 corner|Size as target1|Move and size to target1 |Save target1|Line up to target1 Red w-side|Line up to target1 Green d-side|Line up to target1 Blue h-side|no|Move to target2|Move to target2 corner|Size as target2|Move and size to target2 |Save target2|Line up to target2 Red w-side|Line up to target2 Green d-side|Line up to target2 Blue h-side|no|scale_dj|move_dj|resize_dj|cumulativeScaler_dj|keyboardScaleGroupFloat_dj|extended_options_dj|scaleMoveResize_dj"],#@list3 11
[1.0,1.0,1.0],
[1.0,1.0,1.0]
]
return;end

def selection_dj
dj_ss = Sketchup.active_model.selection;if dj_ss.empty? then Sketchup.active_model.selection.clear;Sketchup.active_model.selection.add(Sketchup.active_model.active_entities[Sketchup.active_model.active_entities.length-1]);end
dj_ss = Sketchup.active_model.selection;if dj_ss.empty? then ;return;end
@dj_sents = [];dj_ss.each{|e|@dj_sents.push(e)}
return;end;# selection_dj

def bBox_dj
if @dj_x0[4][4]!="10" then
Sketchup.active_model.start_operation "dj_Group",true,true,false
copy_group = Sketchup.active_model.active_entities.add_group(@dj_sents)
@dj_x0[3][23]*=@dj_x0[3][22].to_f;@dj_x0[3][22]=1.0.to_f
for i in 0..7;@dj_x0[1][i]=@dj_x0[3][i]=@dj_x0[3][i+14]=1.0;end
for i in 0..5;@dj_x0[1][i+8]=@dj_x0[3][i+8]=@dj_x0[3][i+22];end
for i in 0..5;@dj_x0[0][i]=@dj_x0[0][i+6]=(@dj_x0[2][i]=@dj_x0[2][i+6]);end
#___set bBox_____
end
for i in 0..2;@dj_x0[2][i+3]=@dj_x0[2][i+9]=(@dj_x0[0][i+3]=@dj_x0[0][i+9]=(((copy_group.bounds.center)[i])*@dj_x0[5][0]*@dj_x0[5][2]*@dj_x0[1][9]).to_f).to_s+" "+@dj_x0[3][25].to_s;end
@dj_x0[2][6]=@dj_x0[2][0]=(@dj_x0[0][6] = @dj_x0[0][0] = (((copy_group.local_bounds.width).to_f).to_s).to_f*@dj_x0[5][0]*@dj_x0[5][2]*@dj_x0[1][9]).to_s+" "+@dj_x0[3][25].to_s  
@dj_x0[2][7]=@dj_x0[2][1]=(@dj_x0[0][7] = @dj_x0[0][1] = (((copy_group.local_bounds.height).to_f).to_s).to_f*@dj_x0[5][0]*@dj_x0[5][2]*@dj_x0[1][9]).to_s+" "+@dj_x0[3][25].to_s 
@dj_x0[2][8]=@dj_x0[2][2]=(@dj_x0[0][8] = @dj_x0[0][2] = (((copy_group.local_bounds.depth).to_f).to_s).to_f*@dj_x0[5][0]*@dj_x0[5][2]*@dj_x0[1][9]).to_s+" "+@dj_x0[3][25].to_s 
Sketchup.active_model.start_operation "dj_Group",true,true,false
copy_group.explode
return;end;#bBox_dj

def target_dj
#___ target 
case @dj_x0[3][27].to_s
when "Save target1" then for i in 0..5 ;@dj_x0[5][i+6] =@dj_x0[2][i+6];end;@dj_x0[3][27] = "no";Sketchup.active_model.selection.clear;Sketchup.active_model.selection.add(Sketchup.active_model.active_entities[Sketchup.active_model.active_entities.length-1]);
when "Save target2" then for i in 0..5 ;@dj_x0[5][i+12]=@dj_x0[2][i+6];end;@dj_x0[3][27] = "no";Sketchup.active_model.selection.clear;Sketchup.active_model.selection.add(Sketchup.active_model.active_entities[Sketchup.active_model.active_entities.length-1]);
when "Move to target1" then for i in 0..2 ;@dj_x0[2][i+9] =@dj_x0[5][i+9];end;@dj_x0[3][27] = "no"
when "Move to target2" then for i in 0..2 ;@dj_x0[2][i+9] =@dj_x0[5][i+15];end;@dj_x0[3][27] = "no"
end;#case
return;end;#target_dj

def move_dj
#move!
Sketchup.active_model.start_operation "dj_Group",true,true,false
copy_group = Sketchup.active_model.active_entities.add_group(@dj_sents)
# Thanks sdmitch solved by sdmitch on Thu May 17, 2012 1:48 pm-group.move!
copy_group.move! Geom::Transformation.new Geom::Point3d.new @dj_x0[2][9].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0].to_f-(@dj_x0[2][0].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0]/2.0).to_f,@dj_x0[2][10].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0].to_f-(@dj_x0[2][1].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0]/2.0).to_f,@dj_x0[2][11].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0].to_f-(@dj_x0[2][2].to_f/@dj_x0[5][2]/@dj_x0[1][9].to_f/@dj_x0[5][0]/2.0).to_f
Sketchup.active_model.start_operation "dj_Group",true,false,false
copy_group.explode
return;end;#move_dj

def scaleGroupFloat_dj
Sketchup.active_model.start_operation "dj_Group",true,true,false
selection_dj
bBox_dj
target_dj
move_dj
selection_dj
bBox_dj
target_dj
move_dj
Sketchup.active_model.commit_operation
return;end;# scaleGroupFloat_djSketchup.active_model.start_operation "dj_Group",true,false,true

def onLButtonDown( flag,x, y,dj_view )
dj_xdown = x;dj_ydown = y
dj_view="drawBoxPoint_dj"
dj_point=(Sketchup.active_model.active_view.inputpoint x,y).position


#inputbox
@dj_x0[4][8]=@dj_x0[4][4]
dj_list=['drawBoxPoint_dj|drawboxInside_dj|drawRectangle_dj|drawRectangleInside_dj|SphereTool require 3dshapestool.rb |ConeTool require 3dshapestool.rb |RotatedBox require RotatedBox.rb |BMVB require BMVB.rb']
lists = ["","","",dj_list]
prompts = ["Width cm","Depth cm","Height cm","Mode"]
values = [@dj_x0[5][18],@dj_x0[5][19],@dj_x0[5][20],dj_view]
@results = inputbox prompts, values, lists, "drawBoxPoint_dj"
if not @results then return;end 
@dj_x0[5][18],@dj_x0[5][19],@dj_x0[5][20],dj_view = @results
@dj_x0[5][18]/=0.0254; @dj_x0[5][19]/=0.0254; @dj_x0[5][20]/=0.0254
if dj_view == "SphereTool require 3dshapestool.rb " then Sketchup::require '3dshapestool';Sketchup.active_model.select_tool SphereTool.new;return;end 
if dj_view == "ConeTool require 3dshapestool.rb " then Sketchup::require '3dshapestool';Sketchup.active_model.select_tool ConeTool.new;return;end 
if dj_view == "RotatedBox require RotatedBox.rb " then Sketchup::require 'Rotated Box';Sketchup.active_model.select_tool RotatedBox.new;return;end
if dj_view == "BMVB require BMVB.rb" then Sketchup::require 'BMVB';BMVB::frame;return;end;
#drawboxInside_dj
if dj_view == "drawboxInside_dj" or dj_view == "drawRectangleInside_dj" then 
@dj_x0[4][4]="8"
@dj_x0[3][27]="Save target1"
Sketchup.active_model.start_operation "dj_Group2",true,false,false
scaleGroupFloat_dj
end
# Make drawBoxPoint_dj
Sketchup.active_model.start_operation "dj_Group2",true,false,false
if dj_view == "drawBoxPoint_dj"or dj_view == "drawboxInside_dj"then 
group = Sketchup.active_model.entities.add_group 
#face
pts = [];pts[0] = [dj_point[0], dj_point[1], dj_point[2]];pts[1] = [(dj_point[0]+@dj_x0[5][18]), dj_point[1], dj_point[2]];pts[2] = [(dj_point[0]+@dj_x0[5][18]), (dj_point[1]+@dj_x0[5][19]), dj_point[2]];pts[3] = [dj_point[0], (dj_point[1]+@dj_x0[5][19]), dj_point[2]]
base = group.entities.add_face pts
#pull
base.pushpull @dj_x0[5][20]
#cpoint center
name = group.name = "BoxPoint"
@dj_x0[5][18] *= 0.0254; @dj_x0[5][19] *= 0.0254; @dj_x0[5][20] *= 0.0254
Sketchup.active_model.selection.clear;Sketchup.active_model.selection.add(Sketchup.active_model.active_entities[Sketchup.active_model.active_entities.length-1])
end

if dj_view == "drawRectangle_dj"or dj_view == "drawRectangleInside_dj"then 
group = Sketchup.active_model.entities.add_group 
#face
pts = [];pts[0] = [dj_point[0], dj_point[1], dj_point[2]];pts[1] = [(dj_point[0]+@dj_x0[5][18]), dj_point[1], dj_point[2]];pts[2] = [(dj_point[0]+@dj_x0[5][18]), (dj_point[1]+@dj_x0[5][19]), dj_point[2]];pts[3] = [dj_point[0], (dj_point[1]+@dj_x0[5][19]), dj_point[2]]
base = group.entities.add_face pts
#pull
base.pushpull 0
#cpoint center
name = group.name = "BoxPlain"
@dj_x0[5][18] *= 0.0254; @dj_x0[5][19] *= 0.0254; @dj_x0[5][20] *= 0.0254
Sketchup.active_model.selection.clear;Sketchup.active_model.selection.add(Sketchup.active_model.active_entities[Sketchup.active_model.active_entities.length-1])
end
#drawboxInside_dj part 2
if dj_view == "drawboxInside_dj" or dj_view == "drawRectangleInside_dj" then 
@dj_x0[4][4]="8"
@dj_x0[3][27]="Move to target1";
Sketchup.active_model.start_operation "dj_Group2",true,false,true
scaleGroupFloat_dj
Sketchup.active_model.selection.clear;Sketchup.active_model.selection.add(Sketchup.active_model.active_entities[Sketchup.active_model.active_entities.length-2])
end

@dj_x0[4][4]=@dj_x0[4][8]
Sketchup.active_model.commit_operation 

end
end

end;# Module ScaleGroupFloatDJ

def ScaleGroupFloatDJ.context
UI.add_context_menu_handler do |context|
m = context.add_submenu("scaleGroupFloat_dj")
m.add_item("scaleGroupFloat_dj") { ScaleGroupFloatDJ.scaleGroupFloat_dj }
m.add_item("cumulativeScaler_dj") { ScaleGroupFloatDJ.cumulativejob_dj }
m.add_item("saveTarget1_dj")   { ScaleGroupFloatDJ.save_target1_dj }
m.add_item("moveToTarget1_dj") { ScaleGroupFloatDJ.move_to_target1_dj }
m.add_item("readOutOfaBbox_dj") { ScaleGroupFloatDJ.read_bbox_dj }
m.add_item("drawBoxPoint_dj") { Sketchup.active_model.select_tool ScaleGroupFloatDJ::DrawBoxPointDJ.new }
m.add_item("repeatUndoTool_dj") { ScaleGroupFloatDJ.repeatUndoTool_dj }
m.add_separator
m.add_item("features_dj") { ScaleGroupFloatDJ.listingScaleGroupFloat_dj }
end  #do
end

if( not file_loaded? "scaleGroupFloat_dj_loader.rb" )
ScaleGroupFloatDJ.variables_dj
#ScaleGroupFloatDJ.context

m = UI.menu("Plugins").add_submenu("scaleGroupFloat_dj")
m.add_item("scaleGroupFloat_dj") { ScaleGroupFloatDJ.scaleGroupFloat_dj }
m.add_item("cumulativeScaler_dj") { ScaleGroupFloatDJ.cumulativejob_dj }
m.add_item("saveTarget1_dj")   { ScaleGroupFloatDJ.save_target1_dj }
m.add_item("moveToTarget1_dj") { ScaleGroupFloatDJ.move_to_target1_dj }
m.add_item("readOutOfaBbox_dj") { ScaleGroupFloatDJ.read_bbox_dj }
m.add_item("drawBoxPoint_dj") { Sketchup.active_model.select_tool ScaleGroupFloatDJ::DrawBoxPointDJ.new }
m.add_item("repeatUndoTool_dj") { ScaleGroupFloatDJ.repeatUndoTool_dj }
m.add_separator
m.add_item("features_dj") { ScaleGroupFloatDJ.listingScaleGroupFloat_dj }

m = UI::Toolbar.new "scaleGroupFloat_dj"
# scaleGroupFloat_dj---------------
cmd = UI::Command.new("scaleGroupFloat_dj")  { ScaleGroupFloatDJ.scaleGroupFloat1_dj;ScaleGroupFloatDJ.scaleGroupFloat_dj}
cmd.small_icon =cmd.large_icon ="scaleGroupFloat_dj.png"
cmd.tooltip = "scaleGroupFloat_dj";cmd.status_bar_text = "high precision scaling clipboard fast undo's tool in group mode"
m.add_item cmd
# cumulativeScaler_dj----------------
cmd = UI::Command.new("cumulativeScaler_dj")  {ScaleGroupFloatDJ.cumulativejob_dj}
cmd.small_icon =cmd.large_icon ="cumulativeScaler_dj.png"
cmd.tooltip = "cumulativeScaler_dj";cmd.status_bar_text = "high precision cumulative scaling XYZ clipboard fast undo's tool in group mode"
m.add_item cmd
# Save target1_dj---------------
cmd = UI::Command.new("SaveTarget1_dj")  {ScaleGroupFloatDJ.save_target1_dj}
cmd.small_icon =cmd.large_icon ="moveSize2Target.png"
cmd.tooltip = "Save target1";cmd.status_bar_text = "Save target1 clipboard fast undo's tool in group mode"
m.add_item cmd
# Move to target1_dj ---------------
cmd = UI::Command.new("MoveToTarget1_dj")  {ScaleGroupFloatDJ.move_to_target1_dj}
cmd.small_icon =cmd.large_icon ="moveSize2Target1.png"
cmd.tooltip = "Move to target1";cmd.status_bar_text = "Move to targe1 clipboard fast undo's tool in group mode"
m.add_item cmd
# Read of bbox_dj ---------------
cmd = UI::Command.new("ReadOutOfaBbox_dj")  {ScaleGroupFloatDJ.read_bbox_dj}
cmd.small_icon =cmd.large_icon ="ReadOut.png"
cmd.tooltip = "Reads size and location";cmd.status_bar_text = "Read out of a group bbox,  to delete, hit delete key"
m.add_item cmd
# drawBoxPoint_dj ---------------
cmd = UI::Command.new("drawBoxPoint_dj")  {Sketchup.active_model.select_tool ScaleGroupFloatDJ::DrawBoxPointDJ.new}
cmd.small_icon =cmd.large_icon ="drawBoxPoint_dj.png"
cmd.tooltip = "drawBoxPoint_dj";cmd.status_bar_text = "draw a box and a point clipboard fast undo's tool"
m.add_item cmd
# repeatUndoTool_dj ----repeatUndoTool_dj------RepeatUndoTool_dj-----
cmd = UI::Command.new("repeatUndoTool_dj"){ScaleGroupFloatDJ.repeatUndoTool_dj}
cmd.small_icon = "repeatUndoTool_dj.png";cmd.large_icon = "repeatUndoTool_dj.png"
cmd.tooltip = "repeatUndoTool_dj";cmd.status_bar_text = "repeat undo or redo"
m.add_item cmd
#_repeatTool_dj______________________________________________
cmd = UI::Command.new("features_dj") {ScaleGroupFloatDJ.listingScaleGroupFloat_dj}
cmd.small_icon =cmd.large_icon  = "tips.png"
cmd.tooltip = "features_dj";cmd.status_bar_text = "help"
m.add_item cmd
m.show

#_____menu_____
#add_separator_to_menu("Plugins")  
#UI.menu("Plugins").add_item("scaleGroupFloat_dj_loader.rb ") {ScaleGroupFloatDJ.scale_groupFloat_dj}
end;#if
file_loaded("scaleGroupFloat_dj_loader.rb")
end;# Module DJ
